#include <stdio.h>
#include <stdlib.h>

typedef int key;

typedef enum { red, black } color;

struct rbnode {
	key v;
	color c;
	struct rbnode *left, *right, *up;
}; 

typedef struct rbnode rbnode;

typedef struct {
	rbnode *root, *nil;
} rbtree;

rbtree *createrbtree(void);

void inorder(rbtree *p, void (*op)(rbnode *));

rbnode *search(rbtree *p, key k);

rbnode *treemin(rbtree *p);

rbnode *treemax(rbtree *p);

rbnode *treesucc(rbtree *r, rbnode *q);

rbnode *treepred(rbtree *r, rbnode *q);

void rbinsert(rbtree *p, key k);

void rbdelete(rbtree *r, rbnode *q);
