#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "searchtree.h"

void swap(int *a, int *b)
{
	int t = *a;

	*a = *b;
	*b = t;
}

int *generateperm(int n)
{
	int *a = calloc(n, sizeof(int));
	int i;

	if(!a) { fprintf(stderr,"Errore di Allocazione\n"); exit(-1); }

	for(i = 0; i < n; i++)
		a[i] = i;
	for(i = n-1; i; i--) {
		swap(a + i,a + rand() % i);
	}	
	return a;
}

int *generateperm2(int n)
{
	int i,j,z,zz;
	int *a = calloc(n,sizeof(int));
	char *b = calloc(n,1);	

	if(!a || !b) { fprintf(stderr,"Errore di Allocazione\n"); exit(-1); }
	for(i = 0; i < n; i++) {
		zz = rand() % (n-i);
		for(j = z = 0; j < zz; j++, z++) {
			while(b[z %= n])
				z++;
		}
		while(b[z %= n])
			z++;
		b[z] = 1;
		a[i] = z;
	}
	free(b);
	return a;
}

void stampanodo(searchtree *q)
{
	printf("[%2d]",q->v);
}

void stampalbero(searchtree *p)
{
 	inorder(p,stampanodo);
}

void noprint(searchtree *p) {}

void printtree(searchtree *);

int countlevels(searchtree *p);

int main(int ac, char **av)
{
	int i,j,n,t,*a,*h;
	searchtree *p;
	void (*stampa)(searchtree *) = printtree;
	int *(*generate)(int) = generateperm;

	if(ac != 3) { fprintf(stderr,"La sintassi e' %s dimvettore numvolte\n",av[0]); exit(-2); }
	srand(time(NULL));
	n = atoi(av[1]);  /* atoi converte una stringa che rappresenta un intero in un intero */
	t = atoi(av[2]);  /* il prototipo e' in stdlib.h */
	if(!n || !t) { fprintf(stderr,"Immettere solo numeri positivi come argomenti\n"); exit(-3); }
	h = calloc(t,sizeof(int));
	if(!h) { fprintf(stderr,"Errore di Allocazione"); exit(-1); }
	for(i = 0; i < t; i++) {
		a = generate(n);
		p = createsearchtree();
		putchar('\n');
		for(j = 0;j < n; j++) {
			printf("%d,",a[j]);
			p = insert(p,a[j]);
		}
		putchar('\n');
		stampa(p);
		h[i] = countlevels(p);
		printf("\nAltezza: %d\n",h[i]);
		free(a);
		destroysearchtree(p);
	}
	printf("\nAltezza media:");
	for(i = j = 0; i < t; j += h[i++]);
	printf("%.2f\n",(double)j / t);
}
